<template>
  <div v-if="instance">
    <h6>{{instance.name}}</h6>
    <h6 class="text-muted">
      <app-breadcrumbs :value="breadcrumbs" />
    </h6>
    <form>
      <div class="form-group">
        <label for="survey-question">
          <h3>{{control.label}}</h3>
        </label>
        <input
          v-if="showInput"
          class="form-control"
          id="survey-question"
          name="survey-question"
          v-model="control.value"
        />
      </div>
      <div class="d-flex justify-content-end">
        <button
          type="button"
          class="btn btn-outline-primary mr-2"
          @click="previous"
          v-show="!atStart"
        >Previous</button>
        <button
          type="submit"
          class="btn btn-primary"
          @click.prevent="next"
        >{{ atEnd ? "Submit" : "Next"}}</button>
      </div>
    </form>
  </div>
</template>

<script>
import api from "@/services/api.service";
import _ from "lodash";

import appBreadcrumbs from "./Breadcrumbs.vue";

import {
  getControl,
  getBreadcrumbs,
  getInstanceData,
  getSurveyPositions,
  compileSandboxSingleLine,
  createInstancePayload
} from "../utils";

export default {
  data() {
    return {
      survey: null,
      control: null,
      instance: null,
      instanceData: null,
      positions: null,
      breadcrumbs: [],
      index: 0
    };
  },
  computed: {
    totalQuestions() {
      return 13;
    },
    atStart() {
      return this.index == 0;
    },
    atEnd() {
      return this.index >= this.positions.length - 1;
    },
    showInput() {
      if (this.control.type === "group") {
        return false;
      }

      return true;
    }
  },
  methods: {
    setValue(ev) {
      this.control.value = ev.target.value;
    },
    next() {
      if (this.atEnd) {
        const payload = createInstancePayload(this.instance, this.survey);
        this.submit(payload);
        return;
      }
      this.index++;
      this.instanceData = getInstanceData(this.instance);
      this.control = getControl(this.instance, this.positions[this.index]);
      this.breadcrumbs = getBreadcrumbs(
        this.survey,
        this.positions[this.index]
      );
      this.calculateControl();
    },
    previous() {
      if (this.atStart) {
        return;
      }
      this.index--;
      this.control = getControl(this.instance, this.positions[this.index]);
      this.breadcrumbs = getBreadcrumbs(
        this.survey,
        this.positions[this.index]
      );
    },
    calculateControl() {
      if (
        !this.control.options.calculate ||
        this.control.options.calculate === ""
      ) {
        return;
      }
      const sandbox = compileSandboxSingleLine(this.control.options.calculate);
      this.control.value = sandbox({ data: this.instanceData });
    },
    submit(payload) {
      try {
        api.post("/survey-results", payload);
        this.$router.push("/surveys");
      } catch (error) {
        console.log(error);
      }
    }
  },
  components: {
    appBreadcrumbs
  },
  async created() {
    try {
      const id = this.$route.params.id;
      const { data } = await api.get(`/surveys/${id}`);
      this.survey = data;
      this.instance = _.cloneDeep(this.survey);

      this.positions = getSurveyPositions(this.survey);
      this.instanceData = getInstanceData(this.instance);

      this.index = 0;
      this.control = getControl(this.instance, this.positions[this.index]);
      this.breadcrumbs = getBreadcrumbs(
        this.survey,
        this.positions[this.index]
      );
    } catch (e) {
      console.log("something went wrong:", e);
    }
  }
};
</script>